'''
############################
# BA_SPINNING_COIN_ANIM.PY #
############################
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
 -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
  Filter to create Layers for a Ellie's spinning coin gif
  Brian Andersen July 2017
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
 -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
First get Conbagui's Gold Coin tutorial and make a coin
with a front and back.  You can find it on Gimplearn.net
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
Second, use Ellie's tutorial on Making A Spinning Coin.
You can find that on Gimplearn.net also.
Follow this tutorial to make your background pattern
and a layer stack. 
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
Make the layer stack exactly as it shows in Ella's tutorial.
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
Top layer    =  the Front of the coin
Mid layer    =  the Back of the coin.
Bottom layer =  the pattern for the coins outer edge
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
Save the xcf file just in case and leave it open.
 -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
Run this Spinning Coin plug-in  
 -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
You will have an option for a 10 degree slice, 
or a 10 degree slice 90 degrees out of phase.

Did I mention, It is SLOW, the map object takes
a while, so go browse on Gimplearn for a while while
it is working.
 -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
When it is done, save your .xcf file and then
Ella's tutorial shows you how to your mapped layers
into a nice animated GIF.
 -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -
- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
...................................................... 

'''
#!/usr/bin/env python
from gimpfu import *


def BA_Spinning_Coin_Anim(image,drawable,slice) :

    top =image.layers[0]
    bot =image.layers[1]
    edge=image.layers[2]
    map = edge.copy()
    image.add_layer(map,0)
    map.name = 'map'
    pdb.gimp_image_set_active_layer(image,map)
    drawable = map
    maptype=3
    rotationangle_x= 90.0          
    rotationangle_y= 0.0          
    ambient_intensity=0.3 ; diffuse_intensity=1.0 ; diffuse_reflectivity=0.5 ; specular_reflectivity=.05 ; highlight=27.0
    antialiasing = True
    tiled = False
    newimage = False   
    transparentbackground = True
    radius          =0.25 
    cylinder_length =0.03  
    cyl_top_drawable    = top
    cyl_bottom_drawable = bot
    viewpoint_x  =   0.25 ; viewpoint_y  =   0.25  ; viewpoint_z  =  3.0  
    position_x   =   0.50 ; position_y   =   0.50  ; position_z   =  0.0  
    firstaxis_x  =   1.00 ; firstaxis_y  =   0.00  ; firstaxis_z  =  0.0  
    secondaxis_x =   0.00 ; secondaxis_y =   1.00  ; secondaxis_z =  0.0  
    x_scale=.0 ; y_scale=.0 ; z_scale=.0                                       
    box_front_drawable =None ; box_back_drawable=None ; box_top_drawable  =None 
    box_bottom_drawable=None ; box_left_drawable=None ; box_right_drawable=None  
    lighttype=2           ; lightcolor='#ffffff'  
    lightposition_x =-0.5 ; lightposition_y =-0.5 ; lightposition_z = 2.0    
    lightdirection_x=-1.0 ; lightdirection_y=-1.0 ; lightdirection_z=-1.0    
    if slice == 0:
        for i in (0,10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,-170,-160,-150,-140,-130,-120,-110,-100,-90,-80,-70,-60,-50,-40,-30,-20,-10):
            rotationangle_z= i
            map = edge.copy()
            image.add_layer(map,0)
            map.name = 'map'
            pdb.gimp_image_set_active_layer(image,map)
            drawable = map            
            pdb.plug_in_map_object(image, drawable, maptype, viewpoint_x, viewpoint_y, viewpoint_z, position_x, position_y, position_z, firstaxis_x, firstaxis_y, firstaxis_z, secondaxis_x, secondaxis_y, secondaxis_z, rotationangle_x, rotationangle_y, rotationangle_z, lighttype, lightcolor, lightposition_x, lightposition_y, lightposition_z, lightdirection_x, lightdirection_y, lightdirection_z, ambient_intensity, diffuse_intensity, diffuse_reflectivity, specular_reflectivity, highlight, antialiasing, tiled, newimage, transparentbackground, radius, x_scale, y_scale, z_scale, cylinder_length, box_front_drawable, box_back_drawable, box_top_drawable, box_bottom_drawable, box_left_drawable, box_right_drawable, cyl_top_drawable, cyl_bottom_drawable)
    if slice == 1:  #90 out of phase
        for i in (100,110,120,130,140,150,160,170,180,-170,-160,-150,-140,-130,-120,-110,-100,-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90,):
            rotationangle_z= i
            map = edge.copy()
            image.add_layer(map,0)
            map.name = 'map'
            pdb.gimp_image_set_active_layer(image,map)
            drawable = map            
            pdb.plug_in_map_object(image, drawable, maptype, viewpoint_x, viewpoint_y, viewpoint_z, position_x, position_y, position_z, firstaxis_x, firstaxis_y, firstaxis_z, secondaxis_x, secondaxis_y, secondaxis_z, rotationangle_x, rotationangle_y, rotationangle_z, lighttype, lightcolor, lightposition_x, lightposition_y, lightposition_z, lightdirection_x, lightdirection_y, lightdirection_z, ambient_intensity, diffuse_intensity, diffuse_reflectivity, specular_reflectivity, highlight, antialiasing, tiled, newimage, transparentbackground, radius, x_scale, y_scale, z_scale, cylinder_length, box_front_drawable, box_back_drawable, box_top_drawable, box_bottom_drawable, box_left_drawable, box_right_drawable, cyl_top_drawable, cyl_bottom_drawable)
    #return()    
register(
    "BA_Spinning_Coin_Anim",    
    "generate layers to make a spinning coin gif",   
    "automates gif layer generation",
    "Brian", 
    "Brian Andersen ", 
    "July 2017",
    "BA Spinning Coin Animation", 
    "RGB*", 
    [
      (PF_IMAGE, "image",        "Input image", None),
      (PF_DRAWABLE, "drawable",  "Input drawable", None),
      (PF_OPTION, "slice",       "Slice 360 by", 0, ("10","10 phase90")),     
    ], 
    [],
    BA_Spinning_Coin_Anim,
    menu="<Image>/Brian/",
    )
main()
